<?php

namespace App\Component\Order\Domain;

use App\Component\Customer\Domain\Customer;
use App\Component\File\Domain\File;
use App\Component\Printer\Domain\Printer;
use App\Component\Spool\Domain\Spool;

#[ORM\Entity, ORM\Table(name:"orders")]
class Order
{
    #[ORM\Id, ORM\GeneratedValue(strategy: 'AUTO')]
    #[ORM\Column(type:Types::INTEGER)]
    private int $id;

    private Printer $printer;

    private Customer $customer;

    private Spool $spool;

    private float $printWeights;

    private int $printMinutes;

    private int $printHours;

    private int $userHourlyCost;

    private float $sellPrice;

    private File $file;

    private int $status;

    #[ORM\Column]
    public \DateTime $created;

    #[ORM\Column]
    public \DateTime $updated;

    public function __construct()
    {
    }

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId(int $id): void
    {
        $this->id = $id;
    }

    /**
     * @return Printer
     */
    public function getPrinter(): Printer
    {
        return $this->printer;
    }

    /**
     * @param Printer $printer
     */
    public function setPrinter(Printer $printer): void
    {
        $this->printer = $printer;
    }

    /**
     * @return Customer
     */
    public function getCustomer(): Customer
    {
        return $this->customer;
    }

    /**
     * @param Customer $customer
     */
    public function setCustomer(Customer $customer): void
    {
        $this->customer = $customer;
    }

    /**
     * @return Spool
     */
    public function getSpool(): Spool
    {
        return $this->spool;
    }

    /**
     * @param Spool $spool
     */
    public function setSpool(Spool $spool): void
    {
        $this->spool = $spool;
    }

    /**
     * @return float
     */
    public function getPrintWeights(): float
    {
        return $this->printWeights;
    }

    /**
     * @param float $printWeights
     */
    public function setPrintWeights(float $printWeights): void
    {
        $this->printWeights = $printWeights;
    }

    /**
     * @return int
     */
    public function getPrintMinutes(): int
    {
        return $this->printMinutes;
    }

    /**
     * @param int $printMinutes
     */
    public function setPrintMinutes(int $printMinutes): void
    {
        $this->printMinutes = $printMinutes;
    }

    /**
     * @return int
     */
    public function getPrintHours(): int
    {
        return $this->printHours;
    }

    /**
     * @param int $printHours
     */
    public function setPrintHours(int $printHours): void
    {
        $this->printHours = $printHours;
    }

    /**
     * @return int
     */
    public function getUserHourlyCost(): int
    {
        return $this->userHourlyCost;
    }

    /**
     * @param int $userHourlyCost
     */
    public function setUserHourlyCost(int $userHourlyCost): void
    {
        $this->userHourlyCost = $userHourlyCost;
    }

    /**
     * @return float
     */
    public function getSellPrice(): float
    {
        return $this->sellPrice;
    }

    /**
     * @param float $sellPrice
     */
    public function setSellPrice(float $sellPrice): void
    {
        $this->sellPrice = $sellPrice;
    }

    /**
     * @return File
     */
    public function getFile(): File
    {
        return $this->file;
    }

    /**
     * @param File $file
     */
    public function setFile(File $file): void
    {
        $this->file = $file;
    }

    /**
     * @return int
     */
    public function getStatus(): int
    {
        return $this->status;
    }

    /**
     * @param int $status
     */
    public function setStatus(int $status): void
    {
        $this->status = $status;
    }

    /**
     * @return \DateTime
     */
    public function getCreated(): \DateTime
    {
        return $this->created;
    }

    /**
     * @param \DateTime $created
     */
    public function setCreated(\DateTime $created): void
    {
        $this->created = $created;
    }

    /**
     * @return \DateTime
     */
    public function getUpdated(): \DateTime
    {
        return $this->updated;
    }

    /**
     * @param \DateTime $updated
     */
    public function setUpdated(\DateTime $updated): void
    {
        $this->updated = $updated;
    }

}