<?php

namespace App\Component\User\Domain;

use App\Component\Role\Domain\Role;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;


#[ORM\Entity, ORM\Table(name:"users")]
class User
{

    #[ORM\Id, ORM\GeneratedValue(strategy: 'AUTO')]
    #[ORM\Column(type:Types::INTEGER)]
    private int $id;

    #[ORM\Column(type:Types::STRING, length:255)]
    private string $lastname;

    #[ORM\Column(type:Types::STRING, length:255)]
    private string $firstname;

    #[ORM\ManyToOne(targetEntity: Role::class, inversedBy:"users")]
    protected Role $role;

    #[ORM\Column(type:Types::DECIMAL,length:10, precision:2)]
    private float $kwhPrice;

    #[ORM\Column(type:Types::DECIMAL,length:10, precision:2)]
    private float $hourlyCost;

    #[ORM\Column]
    public \DateTime $created;

    #[ORM\Column]
    public \DateTime $updated;

    public function __construct()
    {
    }

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->id;
    }

    /**
     * @param int $id
     */
    public function setId(int $id): void
    {
        $this->id = $id;
    }

    /**
     * @return string
     */
    public function getLastname(): string
    {
        return $this->lastname;
    }

    /**
     * @param string $lastname
     */
    public function setLastname(string $lastname): void
    {
        $this->lastname = $lastname;
    }

    /**
     * @return string
     */
    public function getFirstname(): string
    {
        return $this->firstname;
    }

    /**
     * @param string $firstname
     */
    public function setFirstname(string $firstname): void
    {
        $this->firstname = $firstname;
    }

    /**
     * @return Role
     */
    public function getRole(): Role
    {
        return $this->role;
    }

    /**
     * @param Role $role
     */
    public function setRole(Role $role): void
    {
        $this->role = $role;
    }

    /**
     * @return float
     */
    public function getKwhPrice(): float
    {
        return $this->kwhPrice;
    }

    /**
     * @param float $kwhPrice
     */
    public function setKwhPrice(float $kwhPrice): void
    {
        $this->kwhPrice = $kwhPrice;
    }

    /**
     * @return float
     */
    public function getHourlyCost(): float
    {
        return $this->hourlyCost;
    }

    /**
     * @param float $hourlyCost
     */
    public function setHourlyCost(float $hourlyCost): void
    {
        $this->hourlyCost = $hourlyCost;
    }

    /**
     * @return \DateTime
     */
    public function getCreated(): \DateTime
    {
        return $this->created;
    }

    /**
     * @param \DateTime $created
     */
    public function setCreated(\DateTime $created): void
    {
        $this->created = $created;
    }

    /**
     * @return \DateTime
     */
    public function getUpdated(): \DateTime
    {
        return $this->updated;
    }

    /**
     * @param \DateTime $updated
     */
    public function setUpdated(\DateTime $updated): void
    {
        $this->updated = $updated;
    }


}